option casemap:none
option frame:auto

UNICODE 				EQU 1
WIN32_LEAN_AND_MEAN 	EQU 1
_WIN64 					EQU 1

include windows.inc
include macros.inc

includelib Kernel32.Lib

include masm64lib.inc


.code

print_wsz proc uses rsi nArgs:QWORD,pwszArgs:VARARG
LOCAL hStdOut:HANDLE
LOCAL qwWritten:QWORD
LOCAL ConsoleCP:QWORD
LOCAL cbBytes:QWORD
LOCAL psz:PCHAR	

	and rsp,-16
	add rsp,-8*8
	
	mov nArgs,rcx
	
	mov pwszArgs[0],rdx
	mov pwszArgs[8],r8
	mov pwszArgs[16],r9
	
	mov rcx,STD_OUTPUT_HANDLE
	call GetStdHandle
	mov hStdOut,rax
	
	mov rcx,rax
	call GetFileType
	mov rsi,rax
	
	lea rdx,qwWritten
	mov rcx,hStdOut
	call GetConsoleMode
	
	.if rsi & FILE_TYPE_CHAR && eax
		lea rsi,pwszArgs
		.while nArgs
			mov rcx,[rsi]
			call wszSize
		
			mov QWORD ptr [rsp+4*8],0
			lea r9,qwWritten
			mov r8,rax
			mov rdx,rcx
			mov rcx,hStdOut
			call WriteConsole
		
			lea rsi,[rsi+8]
			dec nArgs
		.endw
		ret
	.else
		call GetConsoleOutputCP
		mov ConsoleCP,rax
		
		lea rsi,pwszArgs
		.while nArgs
			xor rdx,rdx
			mov [rsp+32+0*8],rdx
			mov [rsp+32+1*8],rdx
			mov [rsp+32+2*8],rdx
			mov [rsp+32+3*8],rdx
			mov r9,-1
			mov r8,[rsi]
			mov rcx,ConsoleCP
			call WideCharToMultiByte
			mov cbBytes,rax
		@@:	test rax,rax
			jz @F	
			
			mov rdx,rax
			mov rcx,GPTR
			call GlobalAlloc
			mov psz,rax
			
			mov rdx,cbBytes
			mov [rsp+32+0*8],rax
			mov [rsp+32+1*8],rdx
			xor rdx,rdx
			mov [rsp+32+2*8],rdx
			mov [rsp+32+3*8],rdx
			mov r9,-1
			mov r8,[rsi]
			mov rcx,ConsoleCP
			call WideCharToMultiByte
			
			mov QWORD ptr [rsp+4*8],0
			lea r9,qwWritten
			mov r8,cbBytes
			lea r8,[r8-1]
			mov rdx,psz
			mov rcx,hStdOut
			call WriteFile
			
			mov rcx,psz
			call GlobalFree
		@@:
			lea rsi,[rsi+8]
			dec nArgs
		.endw
		ret
	.endif	

print_wsz endp

end